% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basal_expression_scaling.R
\name{addBasalExpression}
\alias{addBasalExpression}
\title{Compute basal expresion for gene expression based on the coefficients data frame.}
\usage{
addBasalExpression(dtf_coef, n_genes, basal_expression)
}
\arguments{
\item{dtf_coef}{A data frame containing the coefficients for gene expression.}

\item{n_genes}{number of genes in simulation}

\item{basal_expression}{gene basal expression vector}
}
\value{
A modified data frame \code{dtf_coef} with an additional column containing
the scaling factors for gene expression.
}
\description{
This function takes the coefficients data frame \code{dtf_coef} and computes
basal expression for gene expression. The scaling factors are generated
using the function \code{generate_basal_expression}.
}
\examples{
list_var <- init_variable()
N_GENES <- 5
dtf_coef <- getInput2simulation(list_var, N_GENES)
dtf_coef <- getLog_qij(dtf_coef)
addBasalExpression(dtf_coef, N_GENES, 1)
}
