% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation_initialization.R
\name{add_interaction}
\alias{add_interaction}
\title{Add interaction}
\usage{
add_interaction(list_var, between_var, mu, sd = NA)
}
\arguments{
\item{list_var}{A list of variables (already initialized)}

\item{between_var}{A vector of variable names to include in the interaction}

\item{mu}{Either a numeric value or a numeric vector (of length = level)}

\item{sd}{Either numeric value or NA}
}
\value{
A list with initialized interaction
}
\description{
Add interaction
}
\examples{
init_variable(name = "myvarA", mu = 2, sd = 3, level = 200) \%>\%
init_variable(name = "myvarB", mu = 1, sd = 0.2, level = 2 ) \%>\%
add_interaction(between_var = c("myvarA", "myvarB"), mu = 3, sd = 2)
}
