% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidy_glmmtmb.R
\name{build_missingColumn_with_na}
\alias{build_missingColumn_with_na}
\title{Build DataFrame with Missing Columns and NA Values}
\usage{
build_missingColumn_with_na(
  df,
  l_columns = c("effect", "component", "group", "term", "estimate", "std.error",
    "statistic", "p.value")
)
}
\arguments{
\item{df}{The input DataFrame.}

\item{l_columns}{A character vector specifying the column names to be present in the DataFrame.}
}
\value{
A DataFrame with missing columns added and filled with NA values.
}
\description{
This function takes a DataFrame and a list of column names and adds missing columns with NA values to the DataFrame.
}
\examples{

df <- data.frame(effect = "fixed", term = "Sepal.Length", estimate = 0.7)
df_with_na <- build_missingColumn_with_na(df)
}
