% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_metrics.R
\name{diagnostic_plot}
\alias{diagnostic_plot}
\title{Plot Metrics for Generalized Linear Mixed Models (GLMM)}
\usage{
diagnostic_plot(list_tmb, focus = NULL)
}
\arguments{
\item{list_tmb}{A list of GLMM objects to extract metrics from.}

\item{focus}{A character vector specifying the metrics to focus on. Possible
values include "AIC", "BIC", "logLik", "deviance", "df.resid", and
"dispersion". If \code{NULL}, all available metrics will be plotted.}
}
\value{
A ggplot object displaying histogram plots for the specified metrics.
}
\description{
This function generates a density plot of the specified metrics for the given
list of generalized linear mixed models (GLMMs).
}
\examples{
models_list <-  fitModelParallel(Sepal.Length ~ Sepal.Width + Petal.Length, 
                     group_by = "Species",n.cores = 1, data = iris)
diagnostic_plot(models_list, focus = c("AIC", "BIC", "deviance"))
}
