% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/receiver_operating_characteristic.R
\name{getLabelExpected}
\alias{getLabelExpected}
\title{Get Labels for Expected Differential Expression}
\usage{
getLabelExpected(comparison_df, coeff_threshold, alt_hypothesis)
}
\arguments{
\item{comparison_df}{A data frame containing comparison results with actual effect estimates.}

\item{coeff_threshold}{The threshold value for determining differential expression.}

\item{alt_hypothesis}{The alternative hypothesis for comparison. Possible values are "greater",
"less", and "greaterAbs".}
}
\value{
A modified data frame with an additional column indicating if the gene is differentially expressed.
}
\description{
This function assigns labels to genes based on whether their actual effect estimates
indicate differential expression according to a given threshold and alternative hypothesis.
}
\examples{
# Generate a sample comparison data frame
comparison_data <- data.frame(
  geneID = c("gene1", "gene2", "gene3"),
  actual = c(0.5, -0.3, 0.8)
)

# Get labels for expected differential expression
labeled_data <- getLabelExpected(comparison_data, coeff_threshold = 0.2, alt_hypothesis = "greater")

}
