% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation_report.R
\name{get_eval_data_from_ltmb}
\alias{get_eval_data_from_ltmb}
\title{Extracts evaluation data from a list of TMB models.}
\usage{
get_eval_data_from_ltmb(list_tmb, mock_obj, coeff_threshold, alt_hypothesis)
}
\arguments{
\item{list_tmb}{A list of TMB models.}

\item{mock_obj}{A mock object containing ground truth information.}

\item{coeff_threshold}{The coefficient threshold for wald test}

\item{alt_hypothesis}{The alternative hypothesis for wald test}
}
\value{
A list containing data frames for model parameters and dispersion.
}
\description{
This function takes a list of TMB models, performs tidy evaluation, extracts model parameters,
and compares them to the ground truth effects. Additionally, it evaluates and compares dispersion
inferred from TMB with the ground truth gene dispersion. The results are organized in two data frames,
one for model parameters and one for dispersion, both labeled as "HTRfit".
}
