% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulation_report.R
\name{get_ml_metrics_obj}
\alias{get_ml_metrics_obj}
\title{Get classification metrics for evaluation object}
\usage{
get_ml_metrics_obj(
  evaldata_params,
  alpha_risk = 0.05,
  col_param = "description"
)
}
\arguments{
\item{evaldata_params}{Identity term of the evaluation object.}

\item{alpha_risk}{parameter that sets the threshold for alpha risk level (default 0.05).}

\item{col_param}{parameter that sets the column name for the parameter (default "description").}
}
\value{
A list containing separate data frames for classification metrics by parameter value
and for aggregated classification metrics.
}
\description{
This function extracts the classification metrics. It takes as input (\code{evaldata_params})
and an optional risk level for the alpha risk (\code{alpha_risk}).
It retrieves the p-values from the identity term and computes the binary classification
result by thresholding with the alpha risk level. It then computes the classification metrics
using \code{compute_metrics_summary} function separately for each parameter value as well as
for the aggregated results.
}
