% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fitmodel.R
\name{launchFit}
\alias{launchFit}
\title{Launch the model fitting process for a specific group.}
\usage{
launchFit(data, group_by, formula, ...)
}
\arguments{
\item{data}{Data frame containing the data}

\item{group_by}{Column name in data representing the grouping variable}

\item{formula}{Formula specifying the model formula}

\item{...}{Additional arguments to be passed to the glmmTMB::glmmTMB function}
}
\value{
List with 'glance' and 'summary' attributes representing the fitted model or NULL if there was an error
}
\description{
This function fits the model using the specified group, group_by, formula, and data.
It handles warnings and errors during the fitting process and returns the fitted model or NULL if there was an error.
}
\examples{
launchFit(group_by = "Species", 
           formula = Sepal.Length ~ Sepal.Width + Petal.Length, 
           data = iris[ iris[["Species"]] == "setosa" , ] )
}
