% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subsetgenes.R
\name{subsetGenes}
\alias{subsetGenes}
\title{Subset Genes in Genomic Data}
\usage{
subsetGenes(l_genes, mockObj)
}
\arguments{
\item{l_genes}{A character vector specifying the genes to be retained in the dataset.}

\item{mockObj}{An object containing relevant genomic information to be filtered.}
}
\value{
A modified version of the 'mockObj' data object, with genes filtered according to 'l_genes'.
}
\description{
The 'subsetGenes' function selects and retains genes from 'mockObj' that match the genes specified in 'l_genes'.
}
\details{
This function filters and adjusts genomic data within the Roxygeb project, based on a specified list of genes.
}
\examples{
N_GENES = 100
MAX_REPLICATES = 5
MIN_REPLICATES = 5
input_var_list <- init_variable(name = "varA", mu = 10, sd = 0.1, level = 3)
mock_data <- mock_rnaseq(input_var_list, N_GENES,
                        min_replicates = MIN_REPLICATES, 
                        max_replicates = MAX_REPLICATES)
subset_mockobj <- subsetGenes(mock_data, l_genes = c("gene1", "gene4"))
}
