# WARNING - Generated by {fusen} from /dev/flat_full.Rmd: do not edit by hand


test_that("filter_dataframe retourne le dataframe filtré correctement", {
  # Créer un exemple de dataframe
  df <- data.frame(
  col1 = c(1, 2, 3, 4, 5),
  col2 = c("A", "B", "C", "D", "E"),
  col3 = c("X", "Y", "Z", "X", "Y")
  )
  
  # Créer une liste de filtres
  filter_list <- list(
    col1 = c(2),
    col2 = "B",
    col3 = c("Y")
  )

  # Appliquer les filtres sur le dataframe
  filtered_df <- filter_dataframe(df, filter_list)

  # Vérifier que les lignes correspondantes sont présentes dans le dataframe filtré
  expect_equal(nrow(filtered_df), 1)
  expect_true(all(filtered_df$col1 %in% c(2)))
  expect_true(all(filtered_df$col2 == "B"))
  expect_true(all(filtered_df$col3 %in% c("Y")))
})

test_that("filter_dataframe retourne le dataframe d'origine si aucun filtre n'est spécifié", {
  # Créer une liste de filtres vide
  filter_list <- list()

  # Appliquer les filtres sur le dataframe
  filtered_df <- filter_dataframe(df, filter_list)

  # Vérifier que le dataframe filtré est identique au dataframe d'origine
  expect_identical(filtered_df, df)
})

test_that("calculate_actual_interactionX2_values retourne la valeur d'interaction réelle correctement", {
  average_gt <- data.frame(
  clmn_term_1 = c("A", "A", "B", "B"),
  clmn_term_2 = c("X", "Y", "X", "Y"),
  logQij_mean = c(1.5, 2.0, 85, 1.0)
  )

  # Définir les paramètres de la fonction
  l_label <- list(clmn_term_1 = c("A", "B"), clmn_term_2 = c("X", "Y"))
  clmn_term_1 <- "clmn_term_1"
  lbl_term_1 <- "B"
  clmn_term_2 <- "clmn_term_2"
  lbl_term_2 <- "Y"

  # Calculer la valeur d'interaction réelle
  actual_interaction <- calculate_actual_interactionX2_values(average_gt, l_label, clmn_term_1, lbl_term_1, clmn_term_2, lbl_term_2)

  # Vérifier que la valeur d'interaction réelle est correcte
  expect_equal(actual_interaction, -84.5)
})



test_that("prepareData2computeInteraction filters data correctly", {
  
  data <- data.frame(
  geneID = c("gene1", "gene2", "gene3", "gene4"),
  label_varA = factor(c("A", "A", "B", "B")),
  label_varB = factor(c("X", "X", "Y", "Y")),
  label_varC = factor(c("P", "P", "Q", "Q")),
  logQij_mean = c(1.2, 3.4, 5.6, 7.8)
  )
  categorical_vars <- c("label_varA", "label_varB", "label_varC")
  categorical_varsInInteraction <- c("label_varA", "label_varC")

  dataActual_2computeInteractionValues <- prepareData2computeInteraction(categorical_vars, categorical_varsInInteraction, data)

  expect_equal(nrow(dataActual_2computeInteractionValues), 2)
  expect_true(all(dataActual_2computeInteractionValues$label_varA %in% c("A", "A")))
  expect_true(all(dataActual_2computeInteractionValues$label_varB %in% c("X", "X")))
  expect_true(all(dataActual_2computeInteractionValues$label_varC %in% c("P", "P")))
  expect_equal(dataActual_2computeInteractionValues$logQij_mean, c(1.2, 3.4 ))
})



## TEST
test_that("Generate actual interaction fixed effect correctly", {
  
  ########################################################################"
  N_GENES <- 4
  MIN_REPLICATES <- 3
  MAX_REPLICATES <- 3
  
  init_var <- init_variable(name = "varA", mu = 8, sd = 0.1, level = 3) %>%
  init_variable(name = "varB", mu = c(5, -5), NA, level = 2) %>%
  init_variable(name = "varC", mu = 1, 3, 3) %>%
  add_interaction(between_var = c("varA", "varC"), mu = 5, 0.1)
  
  # -- simulation
  mock_data <- mock_rnaseq(init_var, N_GENES, min_replicates = MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  
  # -- fit data
  data2fit <- prepareData2fit(countMatrix = mock_data$counts, metadata = mock_data$metadata)
  
  dtf_countsLong <- countMatrix_2longDtf(mock_data$counts, "k_ij")
  metadata_columnForjoining <- getColumnWithSampleID(dtf_countsLong, mock_data$metadata)
  
  example_spleID <- as.character(dtf_countsLong[1, "sampleID"])
  regex <- paste("^", as.character(dtf_countsLong[1, "sampleID"]), "$", sep = "")
  
 
  
  
  results_fit <- fitModelParallel(formula = kij ~ varA + varB + varC + varA:varC,
                                data = data2fit, group_by = "geneID",
                                family = glmmTMB::nbinom2(link = "log"), n.cores = 1)
  
  # -- inputs
  tidy_tmb <- tidy_tmb(results_fit)
  fixEff_dataInference <- subsetFixEffectInferred(tidy_tmb)
  fixEff_dataActual <- getData2computeActualFixEffect(mock_data$groundTruth$effects)
  
  interactionTerm <- fixEff_dataInference$fixed_term$interaction[[1]]
  categorical_vars <- fixEff_dataActual$categorical_vars
  dataActual <- fixEff_dataActual$data
  l_labelsInCategoricalVars <- lapply(dataActual[, categorical_vars], levels)
  l_interaction <- strsplit(interactionTerm, split = ":")[[1]]
  l_categoricalVarsInInteraction <- lapply(l_interaction,
                                          function(label) findAttribute(label, l_labelsInCategoricalVars)) %>% unlist()
  
  data_prepared <- prepareData2computeInteraction(categorical_vars, l_categoricalVarsInInteraction, dataActual)
  actual_intercept <- getActualIntercept(fixEff_dataActual)
  l_RefInCategoricalVars <- lapply(dataActual[, categorical_vars], function(vector) levels(vector)[1])
  #######################################################################
  
  actualInteraction <- generateActualInteractionX2_FixEff(l_interaction, l_categoricalVarsInInteraction, 
                                                          data_prepared, l_RefInCategoricalVars)

  # Add your assertions here based on the expected values
  # For example:
  expect_true(nrow(actualInteraction) == 4)
  expect_equal(actualInteraction$geneID,  c("gene1", "gene2", "gene3", "gene4"))
  expect_true(all(actualInteraction$term %in%  'varA2:varC2'))
  #expect_true(all(actualInteraction$description %in%  'interaction'))
  expect_true(is.numeric(actualInteraction$actual))

  # Add more assertions as needed...
})


# Test the function `generateActualInteractionX2_FixEff`
test_that("Test generateActualInteractionX2_FixEff function", {
  # Generate example data
  data <- data.frame(
    geneID = rep(x = c("gene1", "gene2"), each = 8),
    logQij_mean = 1:16
    
  )
  metadata = expand.grid(list(varA = factor(c("A1", "A2")),
    varB = factor(c("B1", "B2")),
    varC = factor(c("C1", "C2"))))
  metadata = rbind(metadata, metadata)
  
  data <- cbind(metadata, data)
  
  categorical_vars <- c("varA", "varB", "varC")
  labelsInInteraction <- c("A2", "C2")
  
  actual_intercept <- data.frame(actual = c(23, 21 ), 
                                 geneID = c("gene1", "gene2"), 
                                 term = c("(Intercept)", "(Intercept)"), 
                                 description = c("(Intercept)", "(Intercept)"))
  # Run the function
  
  actualInteractionValues <- getActualInteractionFixEff(labelsInInteraction, data, categorical_vars  )

  
  # Define the expected output based on the example data
  expected_output <- data.frame(
    term = "A2:C2",
    geneID = c("gene1", "gene2"),
    actual = c(0, 0),
    description = c("A:C", "A:C")
  )
  
  # Add your assertions here to compare the actual output with the expected output
  expect_equal(nrow(actualInteractionValues), nrow(expected_output))
  expect_equal(actualInteractionValues$geneID, expected_output$geneID)
  expect_equal(actualInteractionValues$term, expected_output$term)
  expect_equal(actualInteractionValues$actual, expected_output$actual)
  #expect_equal(actualInteractionValues$description, expected_output$description)

})



# Test for generateActualInteractionX3FixEff
test_that("generateActualInteractionX3FixEff returns correct data frame", {
  
  # Create reference values
  reference <- list(
    varA = c("A1", "A2"),
    varB = c("B1", "B2"),
    varC = c("C1", "C2")
  )
  # Generate example data
  set.seed(123)
  data <- data.frame(
    geneID = rep(x = c("gene1", "gene2"), each = 8),
    logQij_mean = sample(x = -3:12, 16)
    
  )
  metadata = expand.grid(list(varA = factor(c("A1", "A2")),
    varB = factor(c("B1", "B2")),
    varC = factor(c("C1", "C2"))))
  metadata = rbind(metadata, metadata)
  
  data <- cbind(metadata, data)
  
  # Call the function
  result <- generateActualInteractionX3_FixEff(
    labelsInInteraction = c("A2", "B2", "C2"),
    l_categoricalVarsInInteraction = c("varA", "varB", "varC"),
    data2computeInteraction = data,
    l_RefInCategoricalVars = reference
  )
  
  # Check the result
  expect_equal(nrow(result), 2)
  expect_equal(ncol(result), 4)
  expect_identical(result$term, c("A2:B2:C2","A2:B2:C2"))
  expect_equal(result$actual, c(-3, 13))
  expect_identical(result$description, c("A:B:C", "A:B:C"))
})

# Test for calculate_actual_interactionX3_values
test_that("calculate_actual_interactionX3_values returns correct values", {
  # Create reference values
  reference <- list(
    varA = c("A1", "A2"),
    varB = c("B1", "B2"),
    varC = c("C1", "C2")
  )
  # Generate example data
  set.seed(123)
  data <- data.frame(
    geneID = rep(x = c("gene1", "gene2"), each = 8),
    logQij_mean = sample(x = -8:8, 16)
    
  )
  metadata = expand.grid(list(varA = factor(c("A1", "A2")),
    varB = factor(c("B1", "B2")),
    varC = factor(c("C1", "C2"))))
  metadata = rbind(metadata, metadata)
  
  data <- cbind(metadata, data)
  # Call the function
  result <- calculate_actual_interactionX3_values(
    data = data,
    l_reference = reference,
    clmn_term_1 = "varA",
    lbl_term_1 = "A2",
    clmn_term_2 = "varB",
    lbl_term_2 = "B2",
    lbl_term_3 = "C2",
    clmn_term_3 = "varC"
  )
  
  # Check the result
  expect_equal(result, c(-7, 11))
})



## Test interaction X2
test_that("Test getActualInteractionFixEff", {

  # Exemple de données d'entrée
  N_GENES <- 4
  MIN_REPLICATES <- 3
  MAX_REPLICATES <- 3
  
  init_var <- init_variable(name = "varA", mu = 8, sd = 0.1, level = 3) %>%
    init_variable(name = "varB", mu = c(5,-5), NA, level = 2) %>%
    init_variable(name = "varC", mu = 1, 3, 3) %>%
    add_interaction(between_var = c("varA", "varC"), mu = 5, 0.1)
  
  # Simulation
  mock_data <- mock_rnaseq(init_var, N_GENES, min_replicates = MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  
  # Données de fit
  data2fit <- prepareData2fit(countMatrix = mock_data$counts, metadata = mock_data$metadata)
  results_fit <- fitModelParallel(formula = kij ~ varA + varB + varC + varA:varC,
                                  data = data2fit, group_by = "geneID",
                                  family = glmmTMB::nbinom2(link = "log"), n.cores = 1)
  
  # Données d'entrée
  tidy_tmb <- tidy_tmb(results_fit)
  fixEff_dataInference <- subsetFixEffectInferred(tidy_tmb)
  fixEff_dataActual <- getData2computeActualFixEffect(mock_data$groundTruth$effects)
  interactionTerm <- fixEff_dataInference$fixed_term$interaction[[1]]
  categorical_vars <- fixEff_dataActual$categorical_vars
  dataActual <- fixEff_dataActual$data
  l_labelsInCategoricalVars <- lapply(dataActual[, categorical_vars], levels)
  l_interaction <- strsplit(interactionTerm, split = ":")[[1]]
  l_categoricalVarsInInteraction <- lapply(l_interaction,
                                           function(label) findAttribute(label, l_labelsInCategoricalVars)) %>% unlist()
  
  data_prepared <- prepareData2computeInteraction(categorical_vars, l_categoricalVarsInInteraction, dataActual)
  #actual_intercept <- getActualIntercept(fixEff_dataActual)
  
  # Appel de la fonction à tester
  actualInteraction <- getActualInteractionFixEff(l_interaction, data_prepared, categorical_vars)
  

  expect_true(nrow(actualInteraction) == 4)
  expect_equal(actualInteraction$geneID,  c("gene1", "gene2", "gene3", "gene4"))
  expect_true(all(actualInteraction$term %in%  'varA2:varC2'))
  #expect_true(all(actualInteraction$description %in%  'interaction'))
  expect_true(is.numeric(actualInteraction$actual))
})


## Test interaction X3
test_that("Test getActualInteractionFixEff", {

  # Exemple de données d'entrée
  N_GENES <- 4
  MIN_REPLICATES <- 20
  MAX_REPLICATES <- 20
  
 init_var <- init_variable( name = "varA", mu = 3,sd = 1, level = 2) %>%
    init_variable( name = "varB", mu = 2, sd = 2, level = 2) %>%
      init_variable( name = "varC", mu = 2, sd = 1, level = 2) %>%
      add_interaction(between_var = c("varA", 'varC'), mu = 0.3, sd = 1) %>%
      add_interaction(between_var = c("varB", 'varC'), mu = 2, sd = 1) %>%
      add_interaction(between_var = c("varA", 'varB'), mu = -2, sd = 1) %>%
      add_interaction(between_var = c("varA", 'varB', "varC"), mu = 1, sd = 1)
    
  
  # Simulation
  mock_data <- mock_rnaseq(init_var, N_GENES, 
                           min_replicates = MIN_REPLICATES, 
                           max_replicates = MAX_REPLICATES, dispersion = 100)
  
  # Données de fit
  data2fit <- prepareData2fit(countMatrix = mock_data$counts, metadata = mock_data$metadata)
  results_fit <- fitModelParallel(formula = kij ~ varA + varB + varC + varA:varB + varB:varC + varA:varC + varA:varB:varC,
                                  data = data2fit, group_by = "geneID",
                                  family = glmmTMB::nbinom2(link = "log"), n.cores = 1)
  
  # Données d'entrée
  tidy_tmb <- tidy_tmb(results_fit)
  fixEff_dataInference <- subsetFixEffectInferred(tidy_tmb)
  fixEff_dataActual <- getData2computeActualFixEffect(mock_data$groundTruth$effects)
  interactionTerm <- fixEff_dataInference$fixed_term$interaction[[4]]
  categorical_vars <- fixEff_dataActual$categorical_vars
  dataActual <- fixEff_dataActual$data
  l_labelsInCategoricalVars <- lapply(dataActual[, categorical_vars], levels)
  l_interaction <- strsplit(interactionTerm, split = ":")[[1]]
  l_categoricalVarsInInteraction <- lapply(l_interaction,
                                           function(label) findAttribute(label, l_labelsInCategoricalVars)) %>% unlist()
  
  data_prepared <- prepareData2computeInteraction(categorical_vars, l_categoricalVarsInInteraction, dataActual)

  actualInteraction <- getActualInteractionFixEff(l_interaction, data_prepared, categorical_vars)
  

  expect_true(nrow(actualInteraction) == 4)
  expect_equal(actualInteraction$geneID,  c("gene1", "gene2", "gene3", "gene4"))
  expect_true(all(actualInteraction$term %in%  'varA2:varB2:varC2'))
  expect_true(all(actualInteraction$description %in%  'varA:varB:varC'))
  expect_true(is.numeric(actualInteraction$actual))
})


